﻿using GrapeCity.ActiveReports;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace NaNExport
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            var pageReport = new PageReport(GetTablixReportTemplate("NaN Test Report.rdlx"));

            if (pageReport != null)
            {
                var reportData = GetData("NaN Dataset.xml");

                pageReport.Document.LocateDataSource += (object obj, LocateDataSourceEventArgs args) =>
                {
                    args.Data = reportData;
                };

                viewer1.LoadDocument(pageReport.Document);
            }
        }

        private StreamReader GetTablixReportTemplate(string reportName)
        {
            var resourceName = string.Format("NaNExport.{0}", reportName);

            Stream stream = this.GetType().Assembly.GetManifestResourceStream(resourceName);
            stream.Position = 0;
            return new StreamReader(stream);
        }

        private DataTable GetData(string datasetName)
        {
            var resourceName = string.Format("NaNExport.{0}", datasetName);
            Stream stream = this.GetType().Assembly.GetManifestResourceStream(resourceName);
            stream.Position = 0;

            var ds = new DataSet();
            ds.ReadXml(stream, XmlReadMode.ReadSchema);

            return ds.Tables[0];
        }

    }
}
